{$ifdef fpc}{$mode objfpc}{$h+}{$endif}
uses
  testlib,
  Types, Math, SysUtils;

function IsRectInRect(const a, b, c, d: TPoint): Boolean;
begin
  Result :=
    InRange(a.x, c.x, d.x) and InRange(a.y, c.y, d.y) and
    InRange(b.x, c.x, d.x) and InRange(b.y, c.y, d.y);
end;

function IsRectXRect(const a, b, c, d: TPoint): Boolean;
begin
  Result :=
    (b.x > c.x) and (a.x < d.x) and
    (b.y > c.y) and (a.y < d.y);
end;

procedure WAFmt(ACond: Boolean; AFmt: String; AParams: array of const);
begin
  if ACond then Quit(_WA, Format(AFmt, AParams));
end;

function Area(const a, b: TPoint): Int64;
begin
  Result := Int64(b.x - a.x) * Int64(b.y - a.y);
end;

var
  a, b, c, d: TPoint;
  p, q: array [1..10] of TPoint;
  i, j, ma, mo: Integer;
  s, s1, s2: Int64;
begin
  a.x := inf.ReadInteger;
  a.y := inf.ReadInteger;
  b.x := inf.ReadInteger;
  b.y := inf.ReadInteger;
  c.x := inf.ReadInteger;
  c.y := inf.ReadInteger;
  d.x := inf.ReadInteger;
  d.y := inf.ReadInteger;

  c.x := Max(c.x, a.x); c.y := Max(c.y, a.y);
  d.x := Min(d.x, b.x); d.y := Min(d.y, b.y);
  if (c.x <= d.x) and (c.y <= d.y) then
    s2 := Area(c, d)
  else
    s2 := 0;

  mo := ouf.ReadInteger;
  WAFmt(mo > High(p), 'Too many parts: %d', [mo]);
  s := 0;
  for i := 1 to mo do begin
    p[i].x := ouf.ReadInteger;
    p[i].y := ouf.ReadInteger;
    q[i].x := ouf.ReadInteger;
    q[i].y := ouf.ReadInteger;
    WAFmt(p[i].x > q[i].x, 'Rect %d not ordred by X', [i]);
    WAFmt(p[i].y > q[i].y, 'Rect %d not ordred by Y', [i]);
    WAFmt(not IsRectInRect(p[i], q[i], a, b), 'Rect %d not inside survey', [i]);
    WAFmt(IsRectXRect(p[i], q[i], c, d), 'Rect %d intersects restricted area', [i]);
    for j := 1 to i - 1 do
      WAFmt(IsRectXRect(p[i], q[i], p[j], q[j]), 'Rect %d intersects rect %d', [i, j]);
    s := s + Area(p[i], q[i]);
  end;
  s1 := Area(a, b);
  WAFmt(s1 <> s + s2, 'Not fully covered: %d <> %d + %d', [s1, s, s2]);
  
  ma := ans.ReadInteger;
  WAFmt(mo > ma, 'Too many parts: %d > %d', [mo, ma]);
  if mo < ma then Quit(_Fail, Format('Too few parts: %d < %d !', [mo, ma]));
  Quit(_OK, 'ok');
end.
